/*
   crypt.h (full version) by Info-ZIP.   Last revised:  [see CR_VERSION_DATE]

   This header file is not copyrighted, and non-beta versions may be
   distributed without restriction.
 */

#ifndef __crypt_h   /* don't include more than once */
#define __crypt_h

#ifndef CRYPT
#  define CRYPT     /* full version */
#endif

#ifndef __G         /* UnZip only, for now (DLL stuff) */
#  define __G
#  define __G__
#  define __GPRO
#  define __GPRO__
#endif

#define CR_BETA

#define CR_MAJORVER        2
#define CR_MINORVER        5
#ifdef CR_BETA
#  define CR_BETA_VER      "e BETA"
#  define CR_VERSION_DATE  "10 Aug 95"
#else
#  define CR_BETA_VER      ""
#  define CR_VERSION_DATE  "30 September 94"   /* last public release date */
#  define CR_RELEASE
#endif

#ifdef ZIP
#  define GLOBAL(g) g
#  define __G
#  define __G__
#  define __GDEF
#  define __GPRO
#  define __GPRO__
#endif /* ZIP */

#define PWLEN  80   /* input buffer size for reading encryption key */
#define RAND_HEAD_LEN  12    /* length of encryption random header */

/* encode byte c, using temp t.  Warning: c must not have side effects. */
#define zencode(c,t)  (t=decrypt_byte(__G), update_keys(c), t^(c))

/* decode byte c in place */
#define zdecode(c)   update_keys(__G__ c ^= decrypt_byte(__G))

int  decrypt_byte OF((__GPRO void));
int  update_keys OF((__GPRO__ int c));
void init_keys OF((__GPRO__ char *passwd));
void crypthead OF((char *, ulg, FILE *));
char *getp OF((__GPRO__ char *m, char *p, int n));
int  decrypt OF((__GPRO));

#ifndef UNZIP
#  ifdef UTIL
     int zipcloak OF((struct zlist far *, FILE *, FILE *, char *));
     int zipbare OF((__GPRO__ struct zlist far *, FILE *, FILE *, char *));
#  else
     unsigned zfwrite OF((zvoid *, extent, extent, FILE *));
     extern char *key;
#  endif
#endif /* ?UNZIP */

#ifdef FUNZIP
   extern int encrypted;
#  ifdef NEXTBYTE
#    undef NEXTBYTE
#  endif
#  ifdef UNZIP
#    define NEXTBYTE (encrypted? update_keys(__G__ getc(G->in)^decrypt_byte(__G)) : getc(G->in))
#  else
#    define NEXTBYTE (encrypted? update_keys(__G__ getc(in)^decrypt_byte(__G)) : getc(in))
#  endif
#endif /* FUNZIP */

#ifdef VMS
#  define echoff(__G__ f)  echo(0)
#  define echon(__G)    echo(1)
   int echo OF((int));
#else
   void echoff OF((__GPRO__ int));
   void echon OF((__GPRO));
#endif

#if defined(MSDOS) || defined(OS2) || defined(__human68k__) || defined(WIN32)
#  ifndef DOS_NT_OS2
#    define DOS_NT_OS2
#  endif
#endif

#ifdef TOPS20
#  define decrypt_byte   dcrbyt
#endif

#ifdef AMIGA
#  ifndef SIGBREAKF_CTRL_C
#    define SIGBREAKF_CTRL_C (1L << 12)
#  endif
#  if (defined(UNZIP) && !defined(CLIB_EXEC_PROTOS_H))
     void Signal(void *, long), *FindTask(void *);
#  endif
   /* Note: getpid() is only used for random number seeding */
#  define getpid()  (long) FindTask(NULL)       /* more secure than pi */
#  ifdef __SASC_60
#    define echoff(__G__ f)  /* rawcon(1) */
#    define echon(__G)       /* rawcon(0) */
#    define ECHO_NEWLINE()   putc('\n', stderr)
#  else
#    define getch getchar
#    ifdef AZTEC_C
#      define echoff(__G__ f)      set_raw()
#      define echon(__G)           set_con()
#      define ECHO_NEWLINE() putc('\n', stderr)
#    else
#      define echoff(__G__ f)   { fputs("\033[30;40m",stderr);fflush(stderr); }
#      define echon(__G)        { fputs("\033[31;40m",stderr);fflush(stderr); }
#      define ECHO_NEWLINE()
#    endif
#  endif
#endif

#ifdef MACOS
#  define getpid()     3141592654L   /* return PI for PID */
#endif

#endif /* !__crypt_h */
